﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.7
@EndOfDesignText@
'Custom View class
#Event: DateChanged (NewDate As Long)
#DesignerProperty: Key: CancelVisible, DisplayName: Cancel Visible, FieldType: Boolean, DefaultValue: True, Description: Whether the cancel button should be displayed.
#DesignerProperty: Key: TodayVisible, DisplayName: Today Visible, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Modal, DisplayName: Modal Window, FieldType: Boolean, DefaultValue: True, Description: Whether the window should be modal.
#DesignerProperty: Key: MinYear, DisplayName: Minimum Year, FieldType: Int, DefaultValue: 1970, MinRange: 0, MaxRange: 3000
#DesignerProperty: Key: MaxYear, DisplayName: Maximum Year, FieldType: Int, DefaultValue: 2030, MinRange: 0, MaxRange: 3000
#DesignerProperty: Key: FirstDay, DisplayName: First Day, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday, Description: Sets the first day of week.
#DesignerProperty: Key: Title, DisplayName: Title, FieldType: String, DefaultValue: Select Date
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: #FFCFDCDC
#DesignerProperty: Key: SelectedColor, DisplayName: Selected Color, FieldType: Color, DefaultValue: 0xFF0BA29B
#DesignerProperty: Key: HighlightedColor, DisplayName: Highlighted Color, FieldType: Color, DefaultValue: 0xFFABFFFB
Sub Class_Globals
	Private fx As JFX
	Private EventName As String
	Private CallBack As Object
	Private frm As Form
	Private cmbYears As ComboBox
	Private cmbMonths As ComboBox
	Private month, year As Int
	Private boxW, boxH As Float
	Private vCorrection As Float
	Private tempSelectedDay As Int
	Private dayOfWeekOffset As Int
	Private daysInMonth As Int
	Private DaysPane As Pane
	Private cvs As Canvas
	Private cvsBackground As Canvas
	Private selectedDate As Long
	Private selectedYear, selectedMonth, selectedDay As Int
	Private tempSelectedColor As Paint
	Private selectedColor As Paint
	Private lastLeft, lastTop As Double
	Private cvsDays As Canvas
	Private DaysTitlesPane As Pane
	Private dateField As TextField
	Private btnOpen As Button
	Private btnToday As Button
	Private btnCancel As Button
	Private minYear, maxYear, firstDay As Int
	Private modal As Boolean
	'UDG 2016.12.09
	Private cvsSpecial As Canvas
	Private SpecialDays As Map
	Private SpecialDayColor As Paint
	
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	'SpecialDays.Initialize				'UDG: 2016.12.09
	dateField.Initialize("DateField")
	dateField.Style = Lbl.Style 'copy the font related style
	Base.AddNode(dateField, 0,0,0,0)
	btnOpen.Initialize("btnOpen")
	CSSUtils.SetBackgroundImage(btnOpen, File.DirAssets, "calendar_icon.png")
	Base.AddNode(btnOpen, 0,0,0,0) 
	'It is not possible to load a layout file directly from DesignerCreateView.
	CallSubDelayed2(Me, "AfterLoadLayout", Props)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	dateField.SetLayoutAnimated(0, 0, 0, Width - Height, Height)
	btnOpen.SetLayoutAnimated(0, Max(0, Width - Height), 0, Height, Height)
End Sub

Private Sub BtnOpen_Action
	Show
End Sub

Private Sub DateField_TextChanged (Old As String, New As String)
	Dim good As Boolean
	Try
		Dim ticks As Long = DateTime.DateParse(New)
		good =  DateTime.GetYear(ticks) >= minYear And DateTime.GetYear(ticks) <= maxYear
	Catch
		good = False
	End Try
	If good Then
		setDate(ticks)
		CSSUtils.SetBorder(dateField, 0, fx.Colors.White, 0)
		CallSub2(CallBack, EventName & "_DateChanged", ticks)
	Else
		CSSUtils.SetBorder(dateField, 2, fx.Colors.Red, 0)
	End If
End Sub

Private Sub AfterLoadLayout (Props As Map)
	Dim windowHeight As Int = 320
	If Props.Get("CancelVisible") = False And Props.Get("TodayVisible") = False Then windowHeight = 290
	frm.Initialize("frm", 300, windowHeight)
	frm.RootPane.LoadLayout("DatePicker.bjl")
	frm.Title = Props.Get("Title")
	frm.SetFormStyle("UNIFIED")
	frm.SetOwner(Props.Get("Form"))
	frm.Resizable = False
	frm.SetFormStyle("UTILITY")
	CSSUtils.SetBackgroundColor(frm.RootPane, Props.Get("BackgroundColor"))
	selectedColor = Props.Get("SelectedColor")
	tempSelectedColor = Props.Get("HighlightedColor")	
	month = DateTime.GetMonth(DateTime.Now)
	year = DateTime.GetYear(DateTime.Now)
	minYear = Props.Get("MinYear")
	maxYear = Props.Get("MaxYear")
	For y = minYear To maxYear
		cmbYears.Items.Add(y)
	Next
	For Each m As String In DateUtils.GetMonthsNames
		cmbMonths.Items.Add(m)
	Next
	setDate(DateTime.Now)
	cvs.Initialize("cvs")
	cvsSpecial.Initialize("")			'UDG: 2016.12.09
	cvsBackground.Initialize("")
	DaysPane.AddNode(cvsBackground, 0, 0, DaysPane.PrefWidth, DaysPane.PrefHeight)
	DaysPane.AddNode(cvsSpecial, 0, 0, DaysPane.PrefWidth, DaysPane.PrefHeight)  'UDG: 2016.12.09
	DaysPane.AddNode(cvs, 0, 0, DaysPane.PrefWidth, DaysPane.PrefHeight)
	boxW = cvs.Width / 7
	boxH = cvs.Height / 6
	vCorrection = 5
	cvsDays.Initialize("")
	Dim alldays As List = Regex.Split("\|", "Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday") 'need to escape the splitting character.
	firstDay = alldays.IndexOf(Props.Get("FirstDay"))
	DaysTitlesPane.AddNode(cvsDays, 0, 0, DaysTitlesPane.PrefWidth, DaysTitlesPane.PrefHeight)
	Dim daysFont As Font = fx.CreateFont("", 14, True, False)
	Dim i As Int
	Dim days As List = DateUtils.GetDaysNames
	For i = firstDay To firstDay + 7 - 1
		Dim d As String = days.Get(i Mod 7)
		cvsDays.DrawText(d.SubString2(0, 2), (i - firstDay + 0.5) * boxW, 20, daysFont, fx.Colors.Gray, "CENTER")
	Next
	cvs.MouseCursor = fx.Cursors.HAND
	btnCancel.Visible = Props.Get("CancelVisible")
	btnToday.Visible = Props.Get("TodayVisible")
	modal = Props.Get("Modal")
End Sub

Private Sub Show 
	DrawDays
	If lastLeft <> 0 And lastTop <> 0 Then
		frm.WindowLeft = lastLeft
		frm.WindowTop = lastTop
	End If
	If modal Then
		frm.ShowAndWait
	Else
		frm.Show
	End If
	lastLeft = frm.WindowLeft
	lastTop = frm.WindowTop
End Sub

Private Sub DrawDays
	cvs.ClearRect(0, 0, cvs.Width, cvs.Height)
	cvsSpecial.ClearRect(0,0,cvsSpecial.Width,cvsSpecial.Height)	'UDG:2016.12.09
	cvsBackground.ClearRect(0, 0, cvsBackground.Width, cvsBackground.Height)
	Dim firstDayOfMonth As Long = DateUtils.setDate(year, month, 1) - 1
	dayOfWeekOffset = (7 + DateTime.GetDayOfWeek(firstDayOfMonth) - firstDay) Mod 7
	daysInMonth = DateUtils.NumberOfDaysInMonth(month, year)
	If year = selectedYear And month = selectedMonth Then
		'draw the selected box
		DrawBox(cvs, selectedColor, (selectedDay - 1 + dayOfWeekOffset) Mod 7, _
			(selectedDay - 1 + dayOfWeekOffset) / 7)
	End If
	Dim daysFont As Font = fx.CreateFont("", 14, True, False)
	For day = 1 To daysInMonth
		Dim row As Int = (day - 1 + dayOfWeekOffset) / 7
		cvs.DrawText(day, (((dayOfWeekOffset + day - 1) Mod 7) + 0.5) * boxW, _
			(row + 0.5)* boxH + vCorrection, daysFont, fx.Colors.Black, "CENTER")
		'UDG: 2016.12.09
		If isSpecialDay(day) Then 
			DrawBox(cvsSpecial, SpecialDayColor, ((dayOfWeekOffset + day - 1) Mod 7), row)
		End If
	Next
End Sub

Private Sub DrawBox(c As Canvas, clr As Paint, x As Int, y As Int)
	c.DrawRect(x * boxW, y * boxH, boxW, boxH, clr, True, 0)
End Sub

'Gets or sets the selected date
Public Sub getDate As Long
	Return selectedDate
End Sub

Public Sub setDate(date As Long)
	year = DateTime.GetYear(date)
	month = DateTime.GetMonth(date)
	SelectDay(DateTime.GetDayOfMonth(date))
	cmbYears.SelectedIndex = year - cmbYears.Items.Get(0)
	cmbMonths.SelectedIndex = month - 1
End Sub

Private Sub SelectDay(day As Int)
	selectedDate = DateUtils.setDate(year, month, day)
	selectedDay = day
	selectedMonth = month
	selectedYear = year
	Dim s As String = DateTime.Date(selectedDate)
	If dateField.Text <> s Then dateField.Text = s
End Sub

Private Sub cvs_MouseMoved (EventData As MouseEvent)
	HandleMouse(EventData.X, EventData.Y, True)
End Sub

Private Sub cvs_MousePressed (EventData As MouseEvent)
	HandleMouse(EventData.X, EventData.Y, False)
End Sub

Private Sub HandleMouse(x As Double, y As Double, move As Boolean)
	Dim boxX = x / boxW, boxY =  y / boxH As Int
	Dim newSelectedDay As Int = boxY * 7 + boxX + 1 - dayOfWeekOffset
	Dim validDay As Boolean = newSelectedDay > 0 And newSelectedDay <= daysInMonth
	If move Then
		If newSelectedDay = tempSelectedDay Then Return
		cvsBackground.ClearRect(0, 0, cvsBackground.Width, cvsBackground.Height)
		tempSelectedDay = newSelectedDay
		If validDay Then
			DrawBox(cvsBackground, tempSelectedColor, boxX, boxY)
		End If
	Else
		cvsBackground.ClearRect(0, 0, cvsBackground.Width, cvsBackground.Height)
		If validDay Then
			SelectDay(newSelectedDay)
			frm.Close
		End If
	End If
End Sub

Private Sub cmbMonths_SelectedIndexChanged(Index As Int, Value As Object)
	month = Index + 1
	DrawDays
End Sub

Private Sub cmbYears_SelectedIndexChanged(Index As Int, Value As Object)
	year = Value
	DrawDays
End Sub

Private Sub btnToday_Action
	setDate(DateTime.Now)
	frm.Close
End Sub

Private Sub btnCancel_Action
	frm.Close
End Sub

#Region UDG 2016.12.09
'Tests whether day is in the list of days to highlight
Private Sub isSpecialDay(day As Int) As Boolean
	Dim curM, curY As Long
	curM = cmbMonths.SelectedIndex+1
	curY = cmbYears.Items.Get(cmbYears.SelectedIndex)
	Dim dt As Long = DateUtils.SetDate(curY,curM,day)
	If SpecialDays.IsInitialized And SpecialDays.ContainsKey(dt) Then
		SpecialDayColor = SpecialDays.Get(dt)
		Return True
	Else
		Return False
	End If
End Sub

'Updates the list of days to highlight
Public Sub SetSpecialDays(sp As Map)
	SpecialDays = sp
End Sub
#End Region
